package org.appfuse.web;

import javax.servlet.ServletContextEvent;
import javax.servlet.ServletContextListener;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.tapestry.ApplicationServlet;
import org.apache.tapestry.IPage;
import org.apache.tapestry.IRequestCycle;
import org.apache.tapestry.junit.MockEngine;
import org.apache.tapestry.junit.TapestryTestCase;
import org.apache.tapestry.junit.mock.MockContext;
import org.apache.tapestry.junit.mock.MockServletConfig;
import org.apache.tapestry.request.RequestContext;
import org.springframework.mock.web.MockHttpServletRequest;
import org.springframework.mock.web.MockHttpServletResponse;
import org.springframework.mock.web.MockServletContext;
import org.springframework.web.context.ContextLoader;
import org.springframework.web.context.ContextLoaderListener;
import org.springframework.web.context.WebApplicationContext;
import org.springframework.web.context.support.WebApplicationContextUtils;

public class BasePageTestCase extends TapestryTestCase {
    protected final transient Log log = LogFactory.getLog(getClass());
    protected static WebApplicationContext ctx;
    protected MockEngine engine;
    protected MockHttpServletRequest request = new MockHttpServletRequest();
    protected MockHttpServletResponse response = new MockHttpServletResponse();

    // This static block ensures that Spring's BeanFactory is only loaded
    // once for all tests
    static {
        MockServletContext servletContext = new MockServletContext("");
        servletContext.addInitParameter(ContextLoader.CONFIG_LOCATION_PARAM,
                                        "/WEB-INF/applicationContext*.xml");

        ServletContextListener contextListener = new ContextLoaderListener();
        ServletContextEvent event = new ServletContextEvent(servletContext);
        contextListener.contextInitialized(event);

        ctx = WebApplicationContextUtils.getRequiredWebApplicationContext(servletContext);
    }

    protected IPage getPage(Class clazz) throws Exception {
        AbstractInstantiator i = new AbstractInstantiator();
        BasePage result = (BasePage) i.getInstance(clazz);

        // used to indicate executing in a test, so messages lookup will 
        // be friendly to tests
        result.setEngine(new MockEngine());
        result.setRequestCycle(getCycle(request, response));

        return result;
    }

    protected IRequestCycle getCycle(HttpServletRequest request,
                                     HttpServletResponse response)
    throws Exception {
        MockContext servletContext = new MockContext();
        MockServletConfig config =
            new MockServletConfig("servlet", servletContext);
        ApplicationServlet servlet = new ApplicationServlet();

        servlet.init(config);

        engine = new MockEngine();

        RequestContext context = new RequestContext(servlet, request, response);

        return new org.appfuse.web.MockRequestCycle(engine, context);
    }
}
