package org.appfuse.web;

import org.apache.tapestry.PageRedirectException;
import org.appfuse.model.User;
import org.appfuse.service.UserManager;

public class UserFormTest extends BasePageTestCase {
    private UserForm page;
    private Long userId;

    protected void setUp() throws Exception {    
        super.setUp();

        page = (UserForm) getPage(UserForm.class);
        page.setUserManager((UserManager) ctx.getBean("userManager"));
                
        // create a new user
        User user = new User();
        user.setFirstName("Jack");
        user.setLastName("Raible");
        
        // persist to database
        UserManager userManager = 
             (UserManager) ctx.getBean("userManager");
        userManager.saveUser(user);
        userId = user.getId();

    }
    
    protected void tearDown() throws Exception {
        super.tearDown();
        page = null;
    }
    
    public void testEdit() throws Exception {
        MockRequestCycle cycle = (MockRequestCycle) page.getRequestCycle();
        cycle.addServiceParameter(userId);
        page.setRequestCycle(cycle);
        
        page.edit(cycle);

        assertNotNull(page.getUser());
    }
    
    public void testSave() throws Exception {       
        MockRequestCycle cycle = (MockRequestCycle) page.getRequestCycle();
        cycle.addServiceParameter(userId);
        page.setRequestCycle(cycle);
        
        page.edit(cycle);
        assertNotNull(page.getUser());
        try {
            page.save(cycle);
            fail("Redirect didn't occur");
        } catch (PageRedirectException pe) {
            assertNotNull("redirect failed", pe);
        }
    }
    
    public void testRemove() throws Exception {
        User user = new User();
        user.setId(userId);
        page.setUser(user);
        
        try {
            page.delete(page.getRequestCycle());
            fail("Redirect didn't occur");
        } catch (PageRedirectException pe) {
            assertNotNull("redirect failed", pe);
        }
    }
}
