package org.appfuse.web;

import java.util.Date;

import org.appfuse.model.User;
import org.appfuse.service.UserManager;

public class UserListTest extends BasePageTestCase {
    private UserList page;

    protected void setUp() throws Exception {
        super.setUp();
        page = (UserList) getPage(UserList.class);

        // this manager can be mocked if you want a more "pure" unit test
        page.setUserManager((UserManager) ctx.getBean("userManager"));
        
        // default request cycle
        //page.setRequestCycle(getCycle(request, response));
        
        // create a new user
        User user = new User();
        user.setFirstName("Abbie");
        user.setLastName("Raible");
        user.setBirthday(new Date());
        
        // persist to database
        UserManager userManager = 
            (UserManager) ctx.getBean("userManager");
        userManager.saveUser(user);
    }

    protected void tearDown() throws Exception {
        super.tearDown();
        page = null;
    }

    public void testSearch() throws Exception {
        assertTrue(page.getUserManager().getUsers().size() >= 1);
    }
}
