package org.appfuse.web;

import net.sourceforge.jwebunit.WebTestCase;
import org.appfuse.dao.UserDAO;
import org.appfuse.model.User;
import org.springframework.context.ApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;

import java.util.List;

public class UserWebTest extends WebTestCase {
	
    public UserWebTest(String name) {
        super(name);
        getTestContext().setBaseUrl("http://localhost:8080/equinox-tapestry");
        getTestContext().setResourceBundleName("messages");
    }
    
    public void testWelcomePage() {
        beginAt("/");
        assertTitleEqualsKey("index.title");
    }
    
    public void testAddUser() {
        beginAt("/app?service=page/userForm");
        assertTitleEqualsKey("userForm.title");
        setFormElement("$TextField", "Spring");
        setFormElement("lastNameField", "User");
        submit("$Submit");
        assertTextPresent("saved successfully");
    }
    
    public void testListUsers() {
        beginAt("/app?service=page/users");   	
        
        // check that table is present
        assertTablePresent("userList");

        // check that a set of strings are present somewhere in table
        assertTextInTable("userList",
                          new String[] {"Spring", "User"});
    }
    
    public void testEditUser() {
    	  beginAt("/app?service=direct/0/users/$DirectLink&sp=l" + getInsertedUserId());
    	  assertFormElementEquals("$TextField", "Spring");
        submit("$Submit");
        assertTitleEqualsKey("userList.title");
    }

    /**
     * Convenience method to get the id of the inserted user
     * Assumes last inserted user is "Spring User"
     */
    public String getInsertedUserId() {
        String[] paths = {"/WEB-INF/applicationContext*.xml"};
        ApplicationContext ctx = new ClassPathXmlApplicationContext(paths);
        List users = ((UserDAO) ctx.getBean("userDAO")).getUsers();
        // assumed that user inserted in testAddUser() is last user
        return "" + ((User) users.get(users.size() - 1)).getId();
    }
}